#pragma pack (2)
typedef struct t_GetPntInv
{
    double      _far *pkt;
    short       setinc;
    tCallBack   func;
    void        _far *para;
} t_GetPntInv;

typedef struct t_DrawInv
{
    ushort      type;
    void        _far *ptr;
    ushort      lmode;
    ushort      atype;
} t_DrawInv;

typedef struct t_DlgInput
{
    ushort      num;
    char        _far *title;
    t_dlgdta    _far *dta;
} t_DlgInput;

typedef struct t_GetFilename
{
    char        _far *title;
    char        _far *fname;
} t_GetFilename;

typedef struct t_StoreMultiple
{
    double      _far *data;
    ushort      type;
} t_StoreMultiple;

typedef struct t_MegaCMD
{
    char        _far *cmd;
} t_MegaCMD;

typedef struct t_Message
{
    char        _far *str1;
    char        _far *str2;
    char        _far *but1;
    char        _far *but2;
    char        _far *but3;
    short       defbut;
} t_Message;

typedef struct t_MouseHelp
{
    char        _far *str1;
    char        _far *str2;
    ushort      inv;
} t_MouseHelp;

typedef struct t_GetPnt
{
    double      _far *pkt;
    short       setinc;
} t_GetPnt;

typedef struct t_savecount
{
    int         dummy;
} t_savecount;

typedef struct t_SetFuncText
{
    char        _far *text;
} t_SetFuncText;

typedef struct t_CreateEntity
{
    ushort      type;
    t_attribs   _far *attr;
    void        _far *data;
} t_CreateEntity;

typedef struct t_GetTextVal
{
    ushort      type;
    ushort      init;
    t_text      _far *txt;
} t_GetTextVal;

typedef struct t_ReadTxtFile
{
    char        _far *fname;
    char        _far *buf;
    uint        bufsiz;
} t_ReadTxtFile;

typedef struct t_AddPolylnPt
{
    t_polyln    _far *polyln;
    double      _far *mpd;
    double      px;
    double      py;
} t_AddPolylnPt;

typedef struct t_EraseInv
{
    int         dummy;
} t_EraseInv;

typedef struct t_GetDimVal
{
    ushort      type;
    ushort      init;
    t_dimension _far *dim;
} t_GetDimVal;

typedef struct t_PrintDimVal
{
    double      value;
    char        _far *str;
    char        _far *tol1;
    char        _far *tol2;
} t_PrintDimVal;

typedef struct t_ClickEntity
{
    ulong       filter;
    double      _far *pnt;
    t_entity    _far *ent;
    void        _far *edta;
    ushort      esiz;
} t_ClickEntity;

typedef struct t_ExChangeEntity
{
    t_entity    _far *ent;
} t_ExChangeEntity;

typedef struct t_Blink
{
    tCallBack   func;
    void        _far *para;
} t_Blink;

typedef struct t_EntityLoop
{
    ulong       filter;
    tCallBack   func;
    void        _far *para;
    void        _far *edta;
    ushort      esiz;
} t_EntityLoop;

typedef struct t_DrawEntities
{
    ulong       _far *pid;
    ushort      num;
} t_DrawEntities;

typedef struct t_StringInput
{
    char        _far *title;
    char        _far *buf;
    ushort      buflen;
} t_StringInput;

typedef struct t_SelectInit
{
    ulong       filter;
} t_SelectInit;

typedef struct t_SelectLoop
{
    tCallBack   func;
    void        _far *para;
    void        _far *edta;
    ushort      esiz;
} t_SelectLoop;

typedef struct t_InsertMacro
{
    char        _far *fname;
    tCallBack   func;
    void        _far *para;
    void        _far *edta;
    ushort      esiz;
    t_placemac  _far *pmac;
} t_InsertMacro;

typedef struct t_CalcPattern
{
    ushort      which;
    ushort      cnt;
    t_polypt    _far *ppt;
    double      _far *result;
} t_CalcPattern;

typedef struct t_DeleteEntity
{
    ulong       id;
} t_DeleteEntity;

typedef struct t_GetEntity
{
    ulong       id;
    t_entity    _far *ent;
    void        _far *edta;
    ushort      esiz;
} t_GetEntity;

typedef struct t_SetIncPnt
{
    double      _far *pnt;
} t_SetIncPnt;

typedef struct t_InfoLoop
{
    tCallBack   func;
    t_entinfo   _far *inf ;
} t_InfoLoop;

typedef struct t_GetInfo
{
    ushort      iID;
    t_entinfo   _far *inf ;
} t_GetInfo;

typedef struct t_StoreInfo
{
    t_entinfo   _far *inf ;
} t_StoreInfo;

typedef struct t_ExChangeInfo
{
    t_entinfo   _far *inf ;
} t_ExChangeInfo;

typedef struct t_GetAttributes
{
    ushort      type;
    t_attribs   _far *attr;
} t_GetAttributes;

typedef struct t_GetLayerBits
{
    uchar       _far *bits;
} t_GetLayerBits;

typedef struct t_GetGroupBits
{
    uchar       _far *bits;
} t_GetGroupBits;

typedef struct t_GetLayerNames
{
    t_laygrp    _far *lg;
} t_GetLayerNames;

typedef struct t_GetGroupNames
{
    t_laygrp    _far *lg;
} t_GetGroupNames;

typedef struct t_GetGridSets
{
    t_gridsets  _far *grid;
} t_GetGridSets;

typedef struct t_SetAttributes
{
    ushort      type;
    t_attribs   _far *attr;
} t_SetAttributes;

typedef struct t_SetLayerBits
{
    uchar       _far *bits;
} t_SetLayerBits;

typedef struct t_SetGroupBits
{
    uchar       _far *bits;
} t_SetGroupBits;

typedef struct t_SetLayerNames
{
    t_laygrp    _far *lg;
} t_SetLayerNames;

typedef struct t_SetGroupNames
{
    t_laygrp    _far *lg;
} t_SetGroupNames;

typedef struct t_SetGridSets
{
    t_gridsets  _far *grid;
} t_SetGridSets;

typedef struct t_GetCurrentFile
{
    uchar       _far *fname;
} t_GetCurrentFile;

typedef struct t_CreateMacro
{
    t_macro     _far *mac;
    t_mkmacro   _far *mkm;
    ushort      cnt;
    t_placemac  _far *pmac;
} t_CreateMacro;

typedef struct t_MacroLoop
{
    ulong       filter;
    ulong       start;
    tCallBack   func;
    void        _far *para;
    void        _far *edta;
    ushort      esiz;
} t_MacroLoop;

typedef struct t_ClickMacro
{
    double      _far *pnt;
    t_entity    _far *ent;
    void        _far *edta;
    ushort      esiz;
} t_ClickMacro;

typedef struct t_EntityLen
{
    t_entity    _far *ent;
    double      _far *len;
} t_EntityLen;

typedef struct t_PartList
{
    uchar       _far *fmt;
    uchar       _far *out;
    uchar       flags;
} t_PartList;

typedef union t_MegaPars
{
    t_GetPntInv        m_GetPntInv;
    t_DrawInv          m_DrawInv;
    t_DlgInput         m_DlgInput;
    t_GetFilename      m_GetFilename;
    t_StoreMultiple    m_StoreMultiple;
    t_MegaCMD          m_MegaCMD;
    t_Message          m_Message;
    t_MouseHelp        m_MouseHelp;
    t_GetPnt           m_GetPnt;
    t_savecount        m_savecount;
    t_SetFuncText      m_SetFuncText;
    t_CreateEntity     m_CreateEntity;
    t_GetTextVal       m_GetTextVal;
    t_ReadTxtFile      m_ReadTxtFile;
    t_AddPolylnPt      m_AddPolylnPt;
    t_EraseInv         m_EraseInv;
    t_GetDimVal        m_GetDimVal;
    t_PrintDimVal      m_PrintDimVal;
    t_ClickEntity      m_ClickEntity;
    t_ExChangeEntity   m_ExChangeEntity;
    t_Blink            m_Blink;
    t_EntityLoop       m_EntityLoop;
    t_DrawEntities     m_DrawEntities;
    t_StringInput      m_StringInput;
    t_SelectInit       m_SelectInit;
    t_SelectLoop       m_SelectLoop;
    t_InsertMacro      m_InsertMacro;
    t_CalcPattern      m_CalcPattern;
    t_DeleteEntity     m_DeleteEntity;
    t_GetEntity        m_GetEntity;
    t_SetIncPnt        m_SetIncPnt;
    t_InfoLoop         m_InfoLoop;
    t_GetInfo          m_GetInfo;
    t_StoreInfo        m_StoreInfo;
    t_ExChangeInfo     m_ExChangeInfo;
    t_GetAttributes    m_GetAttributes;
    t_GetLayerBits     m_GetLayerBits;
    t_GetGroupBits     m_GetGroupBits;
    t_GetLayerNames    m_GetLayerNames;
    t_GetGroupNames    m_GetGroupNames;
    t_GetGridSets      m_GetGridSets;
    t_SetAttributes    m_SetAttributes;
    t_SetLayerBits     m_SetLayerBits;
    t_SetGroupBits     m_SetGroupBits;
    t_SetLayerNames    m_SetLayerNames;
    t_SetGroupNames    m_SetGroupNames;
    t_SetGridSets      m_SetGridSets;
    t_GetCurrentFile   m_GetCurrentFile;
    t_CreateMacro      m_CreateMacro;
    t_MacroLoop        m_MacroLoop;
    t_ClickMacro       m_ClickMacro;
    t_EntityLen        m_EntityLen;
    t_PartList         m_PartList;
    uchar              buffer[16];
} t_MegaPars;
#pragma pack ()
